//PrcSam01
#include <iom32.h>
#include <inavr.h>
#include <iomacro.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef F_QUARTZ_FREQ
#define F_QUARTZ_FREQ 7.3728
#endif

#ifndef DelayUs
#define DelayUs(Delay) __delay_cycles((unsigned long int)(F_QUARTZ_FREQ*(float)Delay+1.0))
#endif

#ifndef DS_MAX_UNITS
#define DS_MAX_UNITS 4
#endif

#define DS_SEARCH_ROM 0xF0
#define DS_MATCH_ROM 0x55
#define DS_READ_SCRATCH 0xBE
#define DS_START_CONV 0x44
#define DS_SCIP_ROM 0xcc


unsigned char Ds_Units[DS_MAX_UNITS][8+9];

//  DS18B20

//PORTD 0x12; DDRD 0x11;
//     DS18.     !!!
char Ds_Reset()
{char c=1;
 asm ("cbi 0x12,7");//  0 7  PORTD
 asm ("sbi 0x11,7");//   
 DelayUs(480);
 asm ("cbi 0x11,7");//   
 DelayUs(70);
 c=PIND&0x80;
 DelayUs(410);
 if(c) return 0;
 else return 1;
}

void Ds_Wr_Bit(unsigned char c)// 
{char EI=SREG&0x80;
 asm ("cbi 0x12,7");//  0 7  PORTD
 if(EI) __disable_interrupt();// 
 asm ("sbi 0x11,7");//   
 if(c)// 
  {DelayUs(6);
   asm ("cbi 0x11,7");//   
   if(EI) __enable_interrupt();// 
   DelayUs(84);
  }
 else// 
  {DelayUs(60);
   asm ("cbi 0x11,7");//   
   if(EI) __enable_interrupt();// 
   DelayUs(30);
  };
}

char Ds_Rd_Bit()// 
{char c;
 char EI=SREG&0x80;
 asm ("cbi 0x12,7");//  0 7  PORTD
 if(EI) __disable_interrupt();// 
 asm ("sbi 0x11,7");//   
 DelayUs(6);
 asm ("cbi 0x11,7");//   
 DelayUs(9);
 c=PIND&0x80;
 if(EI) __enable_interrupt();// 
 DelayUs(75);
 if(c)  return 1;
 return 0;
}

// .   
void Ds_Wr_Byte(unsigned char c)
{unsigned char i,b=1;
 for (i=0; i<8; i++)
   {Ds_Wr_Bit(c & b);
    b <<= 1;
   };
}

// .   
unsigned char Ds_Rd_Byte()
{unsigned char i,c=0,b=1;
 for (i=0; i<8; i++)
	{if (Ds_Rd_Bit())
	 c |= b;
     b <<= 1;
	};
 return(c);
}

//  DS18   .
//    !!!
unsigned char Ds_Scan()
{unsigned char i,j,k,n, b1, b2, found;
 for(i=0; i<DS_MAX_UNITS; i++)
   {for(j=0; j<17; j++) Ds_Units[i][j]=0;};
//if ( !ow_reset() )
//return(5);
 found = 0;
 for(n=0; n<=found;n++)// 
   {if(!Ds_Reset()) return 0;// return 0  Reset  0
	Ds_Wr_Byte(DS_SEARCH_ROM);
		
	for(i=0; i<64; i++) //  
      {j= i>>3; // 
	   b1 = Ds_Rd_Bit();
	   b2 = Ds_Rd_Bit();
	   if(i<Ds_Units[n][8]) //    
          {Ds_Wr_Bit(Ds_Units[n][j] & (1<<(i & 0x7)));
		   continue;
		  };
	   if (b1 && !b2) // 10 ->  
          {Ds_Units[n][j] |= (1<<(i & 0x7)); 
		   Ds_Wr_Bit(1);
		  };
	   if (!b1 && b2) // 01 ->  
          {Ds_Wr_Bit(0);};
       if (!b1 && !b2) // 00
          {//   
		   if (found < DS_MAX_UNITS)
              {found++;
               for (k=0; k<=8; k++)	Ds_Units[found][k] = Ds_Units[n][k];
               Ds_Units[found][8] = i+1;
			  }
           Ds_Units[n][j] |= (1<<(i & 0x7)); // 
		   Ds_Wr_Bit(1);
		  };
		};
	};
 return (found+1);
}

/*
void Ds_Rd_All()
{unsigned char n,i;
	
 for(n=0; n<DS_MAX_UNITS; n++) {
		if (Ds_Units[n][0]==0)
			continue;
		
		Ds_Reset0();// Ds_Reset()
		Ds_Wr_Byte(DS_MATCH_ROM); // MATCH ROM
		for(i=0; i<8; i++)
			Ds_Wr_Byte(Ds_Units[n][i]);
		
		Ds_Wr_Byte(DS_READ_SCRATCH); // read scratch
		
		for(i=8; i<17; i++)
			Ds_Units[n][i]=Ds_Rd_Byte();
	};
}	
*/
//      . -  .
//       DsReset
//    ,       .
signed short int Ds_Rd_Data(unsigned char NumUnit)
{unsigned char i,Temp[9];
 signed short int Data=0;
#ifdef DS18S20_MODE
 signed short int shTmp;
#endif
 //    - 0.0625
// if (Ds_Units[NumUnit][0]==0) return 0;// ????     
 Ds_Wr_Byte(DS_MATCH_ROM); // MATCH ROM
 for(i=0; i<8; i++)
			Ds_Wr_Byte(Ds_Units[NumUnit][i]);
		
 Ds_Wr_Byte(DS_READ_SCRATCH); // read scratch
 for(i=0; i<9; i++) Temp[i]=Ds_Rd_Byte();
 //Ds_Wr_Byte(DS_START_CONV);//Start Next Conversion

// DS18b 
 Data=(Temp[1]<<8) | Temp[0];

#ifdef DS18S20_MODE // DS18S
 Data &=0xfffe;
 Data <<=3;//? 3 ??
 shTmp=16-Temp[6]-4;
 Data=Data+shTmp;
#endif 
 // DS18b 
 //Data=(Temp[1]<<8) | Temp[0]);

 return Data;
}	

/* // **********   DS1821 **********
//   ,    Ds1821_Flg=1     .
unsigned char Ds1821_Flg=0;
BOOL Ds1821_Init()
{Ds1821_Flg=1;
 if(!Ds_Reset()) return false;
 Ds_Wr_Byte(0x0c);//  
 Ds_Wr_Byte(0x01);// 
 Ds1821_Flg=0;
};

float Ds1821_Rd_Data(unsigned char FirstStart)
{unsigned char i,c;
 signed char T;
 signed short int CountRemain=0,CountPerC=0;
 unsigned short int shift=1;
 float f;

if(FirstStart) //   ,     0
  {f=0.0; goto end_ds_func:};//   ,  

 Ds1821_Flg=1;
loop:;//   
 if(!Ds_Reset()) return 0.0;
 Ds_Wr_Byte(0xac);//Read Status
 c=Ds_Rd_Byte();
 if(!(c&0x80)) goto loop;

//Read Temperature
 if(!Ds_Reset()) return 0.0;
 Ds_Wr_Byte(0xaa);
 T=Ds_Rd_Byte();

//Read CounRemain
 if(!Ds_Reset()) return 0.0;
 Ds_Wr_Byte(0xa0);
 for(i=0;i<9;i++)
  {c=Ds_Rd_Bit();
   if(c) CountRemain |= shift;
   shift <<= 1;
  };

//LoadCounter
 if(!Ds_Reset()) return 0.0;
 Ds_Wr_Byte(0x41);

//Read CountPerC
 shift=1;
 if(!Ds_Reset()) return 0.0;
 Ds_Wr_Byte(0xa0);
 for(i=0;i<9;i++)
  {c=Ds_Rd_Bit();
   if(c) CountPerC |= shift;
   shift <<= 1;
  };
 CountRemain= CountPerC-CountRemain;
 f=(float)CountRemain/(float)CountPerC;
 f=(float)T-0.5+f;

end_ds_func:;_
//Start Next Conversion
 if(!Ds_Reset()) return 0.0; 
 Ds_Wr_Byte(0xee);
 Ds1821_Flg=0;
 return f;
}
*/
